"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Config_1 = require("../constants/Config");
var NotificationModel_1 = require("../models/NotificationModel");
//ACTION TYPES
exports.DATAGRID_DISPLAY_TEMPLATE_CHANGE = 'DATAGRID_DISPLAY_TEMPLATE_CHANGE';
exports.DATAGRID_CHANGE_COLUMN_ORDER = 'DATAGRID_CHANGE_COLUMN_ORDER';
exports.DATAGRID_CHANGE_COLUMN_DISPLAY = 'DATAGRID_CHANGE_COLUMN_DISPLAY';
exports.DATAGRID_CHANGE_COLUMN_WIDTH = 'DATAGRID_CHANGE_COLUMN_WIDTH';
exports.DATAGRID_CHANGE_COLUMN_TEXT_ALIGN = 'DATAGRID_CHANGE_COLUMN_TEXT_ALIGN';
exports.DATAGRID_USER_DISPLAY_TEMPLATES_UPDATE = 'DATAGRID_USER_DISPLAY_TEMPLATES_UPDATE';
exports.DATAGRID_BOOTSTRAP_TEMPLATE = 'DATAGRID_BOOTSTRAP_TEMPLATE';
exports.DATAGRID_SYNCHRONISE_TEMPLATE = 'DATAGRID_SYNCHRONISE_TEMPLATE';
//ACTIONS
//fires an action to change one of the key-value pair display on a card
function changeDisplayTemplate(displayTemplate, dataGridId, serviceId, instanceName) {
    return {
        type: exports.DATAGRID_DISPLAY_TEMPLATE_CHANGE,
        value: { displayTemplate: displayTemplate, dataGridId: dataGridId, serviceId: serviceId, instanceName: instanceName }
    };
}
exports.changeDisplayTemplate = changeDisplayTemplate;
//handle columns order change
function changeColumnOrder(columnId, order, displayMode, dataGridId, serviceId, instanceName) {
    return {
        type: exports.DATAGRID_CHANGE_COLUMN_ORDER,
        value: { columnId: columnId, order: order, displayMode: displayMode, dataGridId: dataGridId, serviceId: serviceId, instanceName: instanceName }
    };
}
exports.changeColumnOrder = changeColumnOrder;
//handle display change of column
function changeColumnDisplay(columnId, display, displayMode, dataGridId, serviceId, instanceName) {
    return {
        type: exports.DATAGRID_CHANGE_COLUMN_DISPLAY,
        value: { columnId: columnId, display: display, displayMode: displayMode, dataGridId: dataGridId, serviceId: serviceId, instanceName: instanceName }
    };
}
exports.changeColumnDisplay = changeColumnDisplay;
//handle column width change
function changeColumnWidth(columnId, way, displayMode, dataGridId, serviceId, instanceName) {
    return {
        type: exports.DATAGRID_CHANGE_COLUMN_WIDTH,
        value: { columnId: columnId, way: way, displayMode: displayMode, dataGridId: dataGridId, serviceId: serviceId, instanceName: instanceName }
    };
}
exports.changeColumnWidth = changeColumnWidth;
//handle column text-align change
function changeColumnTextAlign(columnId, align, displayMode, dataGridId, serviceId, instanceName) {
    return {
        type: exports.DATAGRID_CHANGE_COLUMN_TEXT_ALIGN,
        value: { columnId: columnId, align: align, displayMode: displayMode, dataGridId: dataGridId, serviceId: serviceId, instanceName: instanceName }
    };
}
exports.changeColumnTextAlign = changeColumnTextAlign;
function saveUserDisplayTemplates(api, updatedData, receiveUserInfo, displayNotification, handleErrorDisplay) {
    var _this = this;
    return function (dispatch) { return __awaiter(_this, void 0, void 0, function () {
        var data, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    dispatch(userDisplayTemplatesUpdate());
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, api.put(api.endpoints.REQUEST_USER + '/' + Config_1.REALM, updatedData)];
                case 2:
                    data = _a.sent();
                    dispatch(receiveUserInfo(data));
                    dispatch(displayNotification(NotificationModel_1.default.Type.DETAILS_UPDATED));
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _a.sent();
                    dispatch(handleErrorDisplay(error_1));
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); };
}
exports.saveUserDisplayTemplates = saveUserDisplayTemplates;
function userDisplayTemplatesUpdate() {
    return {
        type: exports.DATAGRID_USER_DISPLAY_TEMPLATES_UPDATE,
        value: undefined
    };
}
exports.userDisplayTemplatesUpdate = userDisplayTemplatesUpdate;
function bootstrapDataGridTemplate(columnHeaders, dataGridId, serviceId, instanceName) {
    return {
        type: exports.DATAGRID_BOOTSTRAP_TEMPLATE,
        value: { columnHeaders: columnHeaders, instanceName: instanceName, serviceId: serviceId, dataGridId: dataGridId }
    };
}
exports.bootstrapDataGridTemplate = bootstrapDataGridTemplate;
function synchroniseDataGridTemplate(columnHeaders, dataGridId, serviceId, instanceName) {
    return {
        type: exports.DATAGRID_SYNCHRONISE_TEMPLATE,
        value: { columnHeaders: columnHeaders, instanceName: instanceName, serviceId: serviceId, dataGridId: dataGridId }
    };
}
exports.synchroniseDataGridTemplate = synchroniseDataGridTemplate;
//# sourceMappingURL=DataGridActions.js.map