"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var helpers_1 = require("@amalto/helpers");
//wordings
var wordings_1 = require("@amalto/wordings");
//get error message giving the locale data string ID
var error = function (id, locale) {
    var wordings = helpers_1.compileWordings(wordings_1.MULTILANGUAGE_WORDINGS, locale);
    return wordings[id] || wordings['inputvalidation.invalid'] || 'Error';
};
exports.checked = function (value, locale) { return value ? undefined : error('inputvalidation.required', locale); };
exports.required = function (value, locale) { return helpers_1.isNotEmpty(value) ? undefined : error('inputvalidation.required', locale); };
exports.email = function (value, locale) { return helpers_1.isValidEmail(value) ? undefined : error('inputvalidation.invalid.email', locale); };
exports.number = function (value, locale) { return value && isNaN(Number(value)) ? error('inputvalidation.invalid.number', locale) : undefined; };
exports.https = function (value, locale) { return value && helpers_1.isValidHttpsUrl(value) ? undefined : error('inputvalidation.invalid.https.url', locale); };
//# sourceMappingURL=index.js.map